Card Transaction Events
A transaction event is the most granular level of the three-level transaction model (Lifecycle → Card Transaction → Transaction Event).
Each transaction event represents an individual network message or fund movement, with an immutable fund movement per event. Use transaction events when you need per-event details such as failure reasons, authorization subtypes, or individual amounts.
Event types: AUTHORIZATION, CLEARING, REVERSAL_AUTH.
Event subtypes: AUTHORIZATION, INCREMENTAL_AUTHORIZATION, VERIFICATION, REVERSAL,
PARTIAL_REVERSAL, EXPIRED_AUTHORIZATION, CLEARING, PARTIAL_CLEARING, CLEARING_REVERSAL.
Data retention: Resources can be queried for a maximum of 2 years from creation.
Learn more about the transaction lifecycle .
GET /api/v1/issuing/card_transaction_eventsGET /api/v1/issuing/card_transaction_events/{id}
Get card transaction events
GET /api/v1/issuing/card_transaction_events
Retrieve a paginated list of transaction events. Each event includes its type, subtype, process result, and per-event amounts. Use the lifecycle_id or card_transaction_id filter to trace the sequence of events within a specific lifecycle or card transaction.
Filter by billing currency (3-letter ISO 4217 code).
Filter by card. Only returns transaction events associated with this card.
Filter by card transaction. Only returns transaction events belonging to this card transaction.
Filter for items created after this date in ISO8601 format (inclusive).
Filter by lifecycle. Only returns transaction events belonging to this lifecycle.
A bookmark for use in pagination to retrieve either the next page or the previous page of results. You can fetch the value for this identifier from the response of the previous API call. To retrieve the next page of results, pass the value of page_after (if not null) from the response to a subsequent call. To retrieve the previous page of results, pass the value of page_before (if not null) from the response to a subsequent call.
Number of related objects to be listed per page. The maximum is 100.
Filter for items created before this date in ISO8601 format (inclusive).
Filter by event type. One of AUTHORIZATION, CLEARING, or REVERSAL_AUTH.
AUTHORIZATION, CLEARING, REVERSAL_AUTH, UNKNOWN
Identifier of the acquiring institution (the merchant's bank).
Authorization code returned for approved transactions.
The amount for this event in the card's billing currency.
Three-letter ISO 4217 currency code for the billing amount.
Unique identifier of the card associated with this transaction event.
Unique identifier of the card transaction this event belongs to.
Currency conversion details, present when the billing currency differs from the transaction currency.
The source currency of the conversion (3-letter ISO-4217 code).
The effective rate of fx after markup, in the from -> to direction.
The target currency of the conversion (3-letter ISO-4217 code).
Date and time when the transaction event was created, in ISO 8601 format.
Details of the digital wallet token used for the transaction, if applicable.
Unique identifier for digital token.
Payment method used. One of: APPLE_PAY, GOOGLE_PAY, CARD_ON_FILE
The date and time when the authorization is set to expire, in ISO 8601 format. After expiry, reserved funds are released. Note: the associated card transaction status may not update to EXPIRED immediately after this time.
The reason the event was declined. Only present when process_result is DECLINED. Learn more about transaction failure reasons .
Fees applied to this specific event.
Fee amount.
Currency in which the fee is charged (3-letter ISO-4217 code).
Fee type. One of: ATM_ACCESS_FEE.
Unique identifier of the transaction event.
Unique identifier of the lifecycle this event belongs to.
The masked primary account number (PAN) of the card.
Details about the merchant where the event originated, including enriched brand information.
Supplemental details providing richer context on the merchant and its brand. Learn more about merchant brand controls .
The unique identifier associated with the merchant category.
The unique identifier for the merchant brand.
The full legal or common name of the merchant.
The unique identifier associated with the merchant's sub-category.
URL of the merchant's logo for display purposes.
The Merchant Category Code (MCC).
The city of the merchant.
The country of the merchant.
Unique identifier for the merchant.
The short name of the merchant.
The postal code of the merchant.
The state or province of the merchant.
Unique identifier assigned to the transaction by the card network.
The point-of-service entry mode indicating how the card was presented. One of: MANUAL, CREDENTIAL_ON_FILE, CONTACTLESS_CHIP, CONTACT_CHIP, or MAGSTRIPE.
The processing outcome for this event. APPROVED or DECLINED.
Data related to remote authentication, present when the transaction was processed via Remote Auth. Null or absent otherwise.
Indicates whether the fallback/default action from the remote auth configuration was applied.
Response time of remote authorization in milliseconds.
Reason for the remote authorization decision.
The response status of the remote auth call. One of: AUTHORIZED, DECLINED.
Indicates whether the remote auth call timed out before a response was received.
Reference number assigned by the acquiring bank, used to link related events (e.g., a clearing to its original authorization).
Risk assessment details for this transaction event.
Risk actions performed for a card transaction, triggered by rules in our risk engine
Risk factors are conditions or variables that increase the likelihood of fraud or financial irregularities, assessed by our risk management system to determine the threat level of a transaction
The outcome of a 3D Secure authentication process, which verifies the identity of a cardholder during an online purchase. Can be one of: ATTEMPTED, AUTHENTICATED, FAILED, NOT_APPLICABLE, NOT_REQUESTED. Learn more about 3D Secure
A more specific classification of the event type. One of: AUTHORIZATION, INCREMENTAL_AUTHORIZATION, VERIFICATION, REVERSAL, PARTIAL_REVERSAL, EXPIRED_AUTHORIZATION, CLEARING, PARTIAL_CLEARING, CLEARING_REVERSAL.
The amount for this event in the merchant's transaction currency.
The category of the transaction, derived from the card scheme's processing code. One of: PURCHASE, CASH_DISBURSEMENT, ACCOUNT_FUNDING, QUASI_CASH, MERCHANT_CREDIT, DISPUTE_CREDIT, ORIGINAL_CREDIT, ELIGIBILITY_INQUIRY, BILL_PAYMENT.
Three-letter ISO 4217 currency code for the transaction amount.
The date and time the transaction occurred as reported by the card network, in ISO 8601 format.
The type of this transaction event. One of: AUTHORIZATION, CLEARING, or REVERSAL_AUTH.
Date and time when the transaction event was last updated, in ISO 8601 format.
A marker for retrieving the next page of results. Include this value in the page request parameter to retrieve subsequent pages.
A marker for retrieving the previous page of results. Include this value in the page request parameter to retrieve previous pages.
| Error status | Description |
|---|---|
| 400 | Possible errors: |
| 401 | Possible errors: |
| 429 | Too many requests |
| 500 | Service unavailable |
$curl --request GET \> --url 'https://api-demo.airwallex.com/api/v1/issuing/card_transaction_events' \> --header 'Authorization: Bearer {{ACCESS_TOKEN}}' \> --header 'Content-Type: application/json'
1{2 "items": [3 {4 "acquiring_institution_identifier": "410964",5 "auth_code": "VJT90Z",6 "billing_amount": 100,7 "billing_currency": "USD",8 "card_transaction_id": "5b2dc266-09ad-4235-b61a-767c7cd6d6ef",9 "conversion_details": {10 "from_currency": "USD",11 "rate": 1.56,12 "to_currency": "AUD"13 },14 "created_at": "2018-03-22T16:08:02+00:00",15 "digital_wallet_token": {16 "id": "6c2dc266-09ad-4235-b61a-767c7cd6d6ea",17 "payment_method": "GOOGLE_PAY"18 },19 "expiry_date": "2026-02-01T16:08:02+00:00",20 "fee_details": [21 {22 "amount": 500,23 "currency": "USD",24 "type": "ATM_ACCESS_FEE"25 }26 ],27 "id": "7f687fe6-dcf4-4462-92fa-80335301d9d2",28 "lifecycle_id": "6c2dc266-09ad-4235-b61a-767c7cd6d6ea",29 "masked_card_number": "************4242",30 "merchant": {31 "additional_merchant_info": {32 "merchant_brand_category_id": 17000,33 "merchant_brand_id": "6c2dc266-09ad-4235-b61a-767c7cd6d6ea",34 "merchant_brand_name": "Meta",35 "merchant_brand_subcategory_id": 17004,36 "merchant_logo_url": "https://example.com/logo.png"37 },38 "category_code": "4829",39 "city": "New York",40 "country": "US",41 "identifier": "012345678910123",42 "name": "Test Merchant",43 "postcode": "10001",44 "state": "NY"45 },46 "network_transaction_id": "386055120641953",47 "pos_entry_mode": "CONTACTLESS_CHIP",48 "process_result": "APPROVED",49 "retrieval_ref": "605103644028",50 "risk_details": {51 "risk_actions_performed": [52 "TRANSACTION_BLOCKED"53 ],54 "risk_factors": [55 "Suspicious transaction velocity"56 ],57 "three_dsecure_outcome": "AUTHENTICATED"58 },59 "subtype": "AUTHORIZATION",60 "transaction_amount": 100,61 "transaction_category": "PURCHASE",62 "transaction_currency": "AUD",63 "transaction_date_time": "2018-03-22T16:08:02+00:00",64 "type": "AUTHORIZATION",65 "updated_at": "2018-03-22T16:08:02+00:00"66 }67 ],68 "page_after": "YWZ0ZXI9MmFjNmEzMjQtM2IwNC00M2JkLThmNTUtOWQ5YzdmZjEzZGZm",69 "page_before": "YmVmb3JlPWVmZDQxZTk3LTU2MzctNDQ5MC04NjNkLTU2MDE5MjIwNDQ2YQ=="70}
Get single card transaction event
GET /api/v1/issuing/card_transaction_events/{id}
Retrieve a single transaction event by its unique identifier. The response includes the event type, subtype, process result, failure reason (if declined), and per-event billing and transaction amounts.
Unique identifier of the transaction event.
Identifier of the acquiring institution (the merchant's bank).
Authorization code returned for approved transactions.
The amount for this event in the card's billing currency.
Three-letter ISO 4217 currency code for the billing amount.
Unique identifier of the card associated with this transaction event.
Unique identifier of the card transaction this event belongs to.
Currency conversion details, present when the billing currency differs from the transaction currency.
The source currency of the conversion (3-letter ISO-4217 code).
The effective rate of fx after markup, in the from -> to direction.
The target currency of the conversion (3-letter ISO-4217 code).
Date and time when the transaction event was created, in ISO 8601 format.
Details of the digital wallet token used for the transaction, if applicable.
Unique identifier for digital token.
Payment method used. One of: APPLE_PAY, GOOGLE_PAY, CARD_ON_FILE
The date and time when the authorization is set to expire, in ISO 8601 format. After expiry, reserved funds are released. Note: the associated card transaction status may not update to EXPIRED immediately after this time.
The reason the event was declined. Only present when process_result is DECLINED. Learn more about transaction failure reasons .
Fees applied to this specific event.
Fee amount.
Currency in which the fee is charged (3-letter ISO-4217 code).
Fee type. One of: ATM_ACCESS_FEE.
Unique identifier of the transaction event.
Unique identifier of the lifecycle this event belongs to.
The masked primary account number (PAN) of the card.
Details about the merchant where the event originated, including enriched brand information.
Supplemental details providing richer context on the merchant and its brand. Learn more about merchant brand controls .
The unique identifier associated with the merchant category.
The unique identifier for the merchant brand.
The full legal or common name of the merchant.
The unique identifier associated with the merchant's sub-category.
URL of the merchant's logo for display purposes.
The Merchant Category Code (MCC).
The city of the merchant.
The country of the merchant.
Unique identifier for the merchant.
The short name of the merchant.
The postal code of the merchant.
The state or province of the merchant.
Unique identifier assigned to the transaction by the card network.
The point-of-service entry mode indicating how the card was presented. One of: MANUAL, CREDENTIAL_ON_FILE, CONTACTLESS_CHIP, CONTACT_CHIP, or MAGSTRIPE.
The processing outcome for this event. APPROVED or DECLINED.
Data related to remote authentication, present when the transaction was processed via Remote Auth. Null or absent otherwise.
Indicates whether the fallback/default action from the remote auth configuration was applied.
Response time of remote authorization in milliseconds.
Reason for the remote authorization decision.
The response status of the remote auth call. One of: AUTHORIZED, DECLINED.
Indicates whether the remote auth call timed out before a response was received.
Reference number assigned by the acquiring bank, used to link related events (e.g., a clearing to its original authorization).
Risk assessment details for this transaction event.
Risk actions performed for a card transaction, triggered by rules in our risk engine
Risk factors are conditions or variables that increase the likelihood of fraud or financial irregularities, assessed by our risk management system to determine the threat level of a transaction
The outcome of a 3D Secure authentication process, which verifies the identity of a cardholder during an online purchase. Can be one of: ATTEMPTED, AUTHENTICATED, FAILED, NOT_APPLICABLE, NOT_REQUESTED. Learn more about 3D Secure
A more specific classification of the event type. One of: AUTHORIZATION, INCREMENTAL_AUTHORIZATION, VERIFICATION, REVERSAL, PARTIAL_REVERSAL, EXPIRED_AUTHORIZATION, CLEARING, PARTIAL_CLEARING, CLEARING_REVERSAL.
The amount for this event in the merchant's transaction currency.
The category of the transaction, derived from the card scheme's processing code. One of: PURCHASE, CASH_DISBURSEMENT, ACCOUNT_FUNDING, QUASI_CASH, MERCHANT_CREDIT, DISPUTE_CREDIT, ORIGINAL_CREDIT, ELIGIBILITY_INQUIRY, BILL_PAYMENT.
Three-letter ISO 4217 currency code for the transaction amount.
The date and time the transaction occurred as reported by the card network, in ISO 8601 format.
The type of this transaction event. One of: AUTHORIZATION, CLEARING, or REVERSAL_AUTH.
Date and time when the transaction event was last updated, in ISO 8601 format.
| Error status | Description |
|---|---|
| 400 | Possible errors: |
| 401 | Possible errors: |
| 429 | Too many requests |
| 500 | Service unavailable |
$curl --request GET \> --url 'https://api-demo.airwallex.com/api/v1/issuing/card_transaction_events/card_transaction_event_id' \> --header 'Authorization: Bearer {{ACCESS_TOKEN}}' \> --header 'Content-Type: application/json'
1{2 "acquiring_institution_identifier": "410964",3 "auth_code": "VJT90Z",4 "billing_amount": 100,5 "billing_currency": "USD",6 "card_transaction_id": "5b2dc266-09ad-4235-b61a-767c7cd6d6ef",7 "conversion_details": {8 "from_currency": "USD",9 "rate": 1.56,10 "to_currency": "AUD"11 },12 "created_at": "2018-03-22T16:08:02+00:00",13 "digital_wallet_token": {14 "id": "6c2dc266-09ad-4235-b61a-767c7cd6d6ea",15 "payment_method": "GOOGLE_PAY"16 },17 "expiry_date": "2026-02-01T16:08:02+00:00",18 "failure_reason": "<string>",19 "fee_details": [20 {21 "amount": 500,22 "currency": "USD",23 "type": "ATM_ACCESS_FEE"24 }25 ],26 "id": "7f687fe6-dcf4-4462-92fa-80335301d9d2",27 "lifecycle_id": "6c2dc266-09ad-4235-b61a-767c7cd6d6ea",28 "masked_card_number": "************4242",29 "merchant": {30 "additional_merchant_info": {31 "merchant_brand_category_id": 17000,32 "merchant_brand_id": "6c2dc266-09ad-4235-b61a-767c7cd6d6ea",33 "merchant_brand_name": "Meta",34 "merchant_brand_subcategory_id": 17004,35 "merchant_logo_url": "https://example.com/logo.png"36 },37 "category_code": "4829",38 "city": "New York",39 "country": "US",40 "identifier": "012345678910123",41 "name": "Test Merchant",42 "postcode": "10001",43 "state": "NY"44 },45 "network_transaction_id": "386055120641953",46 "pos_entry_mode": "CONTACTLESS_CHIP",47 "process_result": "APPROVED",48 "retrieval_ref": "605103644028",49 "risk_details": {50 "risk_actions_performed": [51 "TRANSACTION_BLOCKED"52 ],53 "risk_factors": [54 "Suspicious transaction velocity"55 ],56 "three_dsecure_outcome": "AUTHENTICATED"57 },58 "subtype": "AUTHORIZATION",59 "transaction_amount": 100,60 "transaction_category": "PURCHASE",61 "transaction_currency": "AUD",62 "transaction_date_time": "2018-03-22T16:08:02+00:00",63 "type": "AUTHORIZATION",64 "updated_at": "2018-03-22T16:08:02+00:00"65}